#include <malloc.h>
#include <stdio.h>
#include <string.h>

typedef
	struct kunde_t {
	int kdnr;
	char name[64];
	char adresse[64];
	struct kunde_t* next;
} cust;

cust* list_find(cust* e,int kdnr) {
	if(e != NULL) {
		if(e->kdnr == kdnr) // Gefunden!
			return e;
		else // weitersuchen ...
		  	return list_find(e->next,kdnr);
	}
	else // Ende der Liste erreicht
		return NULL;
};

// Vorgaenger finden (rekursiv)
cust* list_find_prev(cust* first,cust* e) {
	if(!first) /* konnte keinen Vorgnger finden */
		return NULL;

	if(first->next == e) /* aktuelles "first" ist Vorgnger */
		return e;
	else
		return list_find_prev(first->next,e);
};


/* Rekursiv */
void list_delete(cust* first) {
	if(first == NULL)
		return;

	cust* next = first->next;
	free(first);
	list_delete(next);
}

/* Idee: Setze Next-Zeiger vom Vorgnger von "e" auf 	Nachfolger von "e"
   Rckgabewert: erstes Element der Liste (Warum?)
*/
cust* list_delete_element(cust* first,cust *e) {
	/* bestimme Zeiger auf Vorgnger- und Nachfolgerelemente */

	cust* e_prev = list_find_prev(first,e); /* finde Vorgnger von e (?)*/
	cust* e_next = e->next;					/* Nachfolger von e*/
	free(e); 								/* lsche speicher */
	if(e_prev != NULL) { 					// Verkette Vorgnger mit Nachfolger
		e_prev->next = e_next;
		free(e);
		return first;						// 1. Element der Liste zurckgeben
	}
	else 						// e ist 1. Element (kein Vorgnger)
		return e_next;			// neues 1. Element zurckgeben
}


/* Create new list with one element and return by Pointer */
cust* list_create() {
	cust* c;
	c = malloc(sizeof(cust));
	c->next = NULL;
	return c;
}

/* 	Create new element before "e".
	Return new first element of the list */
cust* list_new_element(cust* e) {
	cust* new;
	new = malloc(sizeof(cust));
	new->next = e;
	return new;
}

int main() {
	cust* e1 = list_create(); // Neue List mit einem Element
 	strcpy(e1->name,"Peter"); strcpy(e1->adresse,"Berlin");	e1->kdnr = 1;

	// Nach element "e1" neues Element einfgen
	cust* e2 = list_new_element(e1);
	strcpy(e2->name,"Frank"); strcpy(e2->adresse,"Bonn");	e2->kdnr = 2;

	cust* e3 = list_new_element(e1);
	strcpy(e3->name,"Jana");  strcpy(e3->adresse,"Prag");	e3->kdnr = 7;

	// finde Eintrag mit Kundennummer 3
	cust* e = list_find(e1,7);
	if(e == NULL)
		printf("Kundennummer 7 nicht gefunden\n");
	else
		printf("Kundennummer 7 ist %s\n",e->name);

	// lsche ganze Liste (erstes Element angeben)
	list_delete(e1);
};

