#include <malloc.h>
#include <stdio.h>
#include <string.h>

typedef struct kunde_t {
	int kdnr;
	char name[64];
	char adresse[64];
} cust;

/* gib Datenbank aus */
void print(cust* db,int n) {
	while(n--) {
		printf("\n=== Kundennummer %d ===\nName: %s\nAdresse: %s\n",db->kdnr,db->name,db->adresse);
		db++;
	}

}

/* gebe Index des Eintrages mit passender Kundennummer zurueck.
	wenn nicht zu finden, dann gib -1 zurck */
int find_entry(cust* db,int n,int kdnr) {
	int i = 0;
	for(;i<n;++i) {
		if(db[i].kdnr == kdnr)
			return i;
	}

	return -1;
}

/* loesche Eintrag aus Array. Dazu muss ein neues Array angelegt werden
 und das alte bis auf das zu lschende Element kopiert werden. */
cust* delete_entry(cust* db,int* n,int kdnr) {
	int d = find_entry(db,*n,kdnr);

	if(d == -1) {
		printf("Kann Eintrag mit Kundennummer %d nicht finden\n",kdnr);
		// gib alte Datenbank zurck
		return db;
	}
	else {
		// loesche Eintrag auf index "d"
		cust* db2 = malloc((*n-1)*sizeof(cust));
		int i = 0;
		int j = 0;
		for(;i<*n;i++) {
			if(i != d) // alle kopieren, ausser zu loeschenden Eintrag
				db2[j++] = db[i];
		}
		// gib alte Datenbank frei
		free(db);
		// setze Anzahl in DB auf n-1
		*n = *n - 1;
		// und neue Datenbank zurck
		return db2;
	}
}

int main() {
	int n = 4;
	cust* db = malloc(sizeof(cust)*n);	// Datenbank fr 4 kunden

	// Initialisiere Datenbank
	db[0].kdnr = 1; strcpy(db[0].name,"Peter"); strcpy(db[0].adresse,"Berlin");
	db[1].kdnr = 81; strcpy(db[1].name,"Arvid"); strcpy(db[1].adresse,"Berlin");
	db[2].kdnr = 34; strcpy(db[2].name,"Lydia"); strcpy(db[2].adresse,"Frankfurt");
	db[3].kdnr = 17; strcpy(db[3].name,"Dr. Frank"); strcpy(db[3].adresse,"Bonn");

	while(n) {
		printf("\n\n\n---------------------------\nDatenbank Groesse: %d\n",n);
		print(db,n);
		fflush(stdin);
		fflush(stdout);
		printf("Bitte zu loeschende Kundennummer eingeben:");
		int kdnr;
		scanf("%d",&kdnr);
		db = delete_entry(db,&n,kdnr);
	}

	free(db);
}